#include <stdio.h>
#include <stdlib.h>  
#include <math.h>  
#include <malloc.h> 
#include <time.h>

int Bias_Correction;



#include "qsort.c"
#include "bds_prod_integral_comp.c"
#include "bds_g.c"
#include "bds_stat_lebaron.c"
#include "rang.c"
#include "series.c"


main()
{  
	
	FILE *fp, *fp1;
	double **MM, *NN;
	double theta[5], var[20], eps, *x, cte[20];
	double param, temp2, rej_cvm[5][20]; 
	double seuil[6][20], c[20], stat[20];
	int n, k, i, r, p, serie[6], l, *rangs; 
	long int it, j;
	long int rej[20];
	static char *nom_loi[17] = { " ", "AR(1) Gaussian", "AR(1) Logistic", "AR(1) Laplace",
		"AR(1) Cauchy", "MA", "NLMA", "GARCH", "ARCH",  "Tent map", "MART", "Feigenbaum", "Threshold", 
		"Clayton", "Frank", "Ali-Mikhail-Haq","Farlie-Gumbel-Morgenstern",};
	long int *ii;
	unsigned long int i0, j00, k0;
	int loi[10],rr;
	time_t *tloc;
	char *fichier[16];
	
	/********** Fixation du seed **********/
	ii = (long int *)malloc(sizeof(long int));  
	tloc=(time_t*)malloc(sizeof(time_t));  
	*ii=time(tloc);  
	j00=*ii*rand()*123;  
	k0=*ii*rand()*756;  
	i0=*ii*rand()*6675;  
	kisset(i0,j00,k0);   
	
	/****  Allocation de la mmoire  ****/
	
	
	loi[1]=1; loi[2]=3;loi[3]=4; loi[4]=5; loi[5]=7; loi[6]=8; loi[7]=9; loi[8]=12; loi[9]=13;
	


	
	/**** Paramtres de la simulation ****/ 
	/****   (  changer au besoin )   ****/
	
	
	serie[0] = 20;   /*** Longueurs ***/ 
	serie[1] = 50;   /***   des    ***/
	serie[2] = 100;  /***  sries  ***/
	serie[3] = 200;
	serie[4] = 500;
	serie[5] = 1000;
	
	
	
	it = 10000;    /*** Nombre d'itrations ***/
	
	p =6;
	
	
	
	fichier[0] = "ResINT/resN4-20.dat";        /****************/
	fichier[1] = "ResINT/resN4-50.dat";        /**  Noms des  **/
	fichier[2] = "ResINT/resN4-100.dat";       /**  fichiers  **/
	fichier[3] = "ResINT/resN4-200.dat";       /**   sortie   **/
	fichier[4] = "ResINT/resN4-500.dat";       /****************/
	fichier[5] = "ResINT/resN4-1000.dat";
	
	
	theta[4] = 0.25; 
	theta[3] = 0.125; 
	theta[2] = 0.0625;
	theta[1] = 0.03125; 
	theta[0] = 0.0;           
	
	
	
	
	
	for(l=2;l<3;l++)      /* Sample size */
	{ 
		
		
		
		n = serie[l];
		printf("\n  n=%d ", n);
		/* Lecture des seuils  
		The file "seuil.txt" contains the critical values for m=2,3,..6 for each 
		of the following statistics as defined in Genest et al. JASA paper 2006. 
		Row 0: BDS,$S_n$
		Row 1: $\tilde S_n^*$,
		Row 2: $\tilde I_n^*$,
		Row 3: $\tilde M_n^*$,
		Row 4: $\tilde T_n^*$,
		Row 5: $\tilde S_n$,
		Row 6: $\tilde I_n$,
		Row 7: $\tilde M_n$,
		Row 8: $\tilde T_n$, */
		
		
		fp1 = fopen("seuil.txt","r");	
		for(k=0;k<9;k++) {fscanf(fp1," %lf %lf %lf %lf %lf\n", &seuil[k][0], &seuil[k][1], &seuil[k][2], &seuil[k][3], &seuil[k][4]);}
		fclose(fp1);
		
		printf("\n  n=%d ", n);
		
		x = calloc(n,sizeof(double)); 
		rangs = calloc(n+p,sizeof(int));
		NN = calloc(n+1,sizeof(double)); 
		MM = calloc(n+1,sizeof(double)); 
		for(i=0; i<=n; i++){MM[i] = calloc(n+1,sizeof(double)); }
		
		matM_BDS_integral(n, MM,eps);
		
		
		
		fp1 = fopen(fichier[l], "a");
		
		fprintf(fp1, "\\begin{center}\n {\\sc Tableau $\\tilde T_n$}:Percentage of rejection at level $\\alpha=.05$ for a series of length $n=%d$, as estimated with $%ld$ replicates.\\\\", n,it);
		fprintf(fp1, "\n {\\tiny \n\n");  
		fprintf(fp1, "\\begin{tabular}{lrrrrrr} \n\\hline \\, \\\\\n");
		fprintf(fp1, "Model  & $p$ & $\\theta=0$ & $\\theta=1/32$ & $\\theta=1/16$ & $\\theta=1/8$ & $\\theta=1/4$\\\\ \n\\hline \\\\ \n");
		
		for(r=1;r<10;r++)     /* law */
		{
			rr=loi[r];
            for(i=0;i<5;i++)  /* theta */       
            { 
				printf("\n %s, theta=%.5lf \n", nom_loi[rr], theta[i]);
				param = theta[i];
				
				for(k=2;k<=p;k++) { rej[k]= 0; }
				
				for(j=0;j<it;j++)
				{  
					laws(x, n, rr, param); 
					rank(x, n, rangs);
					
					for(k=n;k<n+p;k++)
						rangs[k] = rangs[k-n];
					
					bds_rank_lebaron2(rangs, n, p, stat, MM );
					
					for(k=2;k<= p;k++) 
					{ 
						if (fabs(stat[k]) > seuil[l][k])
						{ 
							rej[k] += 1;
						}
						
					}
					
					if( ((j+1) % 500) == 0) { printf("%ld ", j+1);  }
					
				}   /* end of iterations */
				
				for(k=2;k<=p;k++)
					rej_cvm[i][k] = 100*((double)rej[k])/((double)it); 
				
				
            }    /* theta done */
            fprintf(fp1, "\n ");
            for(k=2;k<=p;k++){
				fprintf(fp1, "%s & %d &  %.2lf & %.2lf & %.2lf & %.2lf & %.2lf\\\\ \n", nom_loi[rr], k, rej_cvm[0][k], rej_cvm[1][k], rej_cvm[2][k], rej_cvm[3][k], rej_cvm[4][k]);
				printf("\n %s & %d &  %.2lf & %.2lf & %.2lf & %.2lf & %.2lf\\\\ \n", nom_loi[rr], k, rej_cvm[0][k], rej_cvm[1][k], rej_cvm[2][k], rej_cvm[3][k], rej_cvm[4][k]);
            }
			
			
			
		}   /* change of law */
		
		
		fprintf(fp1, "\n\\hline");          
		fprintf(fp1,"\n\\end{tabular}}");  
		fprintf(fp1, "\n\\end{center}");          
		fclose(fp1);          
		
		
		free(x); free(rangs); free(NN);
		for(i=0;i<=n;i++) free(MM[i]); free(MM);
	}   /* change of sample size */
	
   }