#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <malloc.h>
#include <sys/types.h>
#include <time.h>
#include "bds_stat_lebaron.c"
//#include "kilani/kiss.c"
#include "kilani/qsort.c"
#include "series.c"


 /**********************************************************************/ 
 /* programme: quantiles for the classical BDS TEST                                          */ 
 /*                                                                    */ 
 /* utilit: Calcul des diffrents quantiles de la loi des statisti-   */ 
 /*          ques du tau de Kendall ainsi que de Kolmogorov-Smirnov    */ 
 /*          et de Cramr-von Mises, pour diffrentes longueurs de     */ 
 /*          sries n, pour le processus de Kendall sriel de dlai 1  */ 
 /*                                                                    */ 
 /* fonctions utilises :-bds.c ( Calcul de bds-cvm )                  */ 
 /*                      -qsort.c (trie un vecteur en ordre croissant) */   
 /*                      -kiss.c ( gnration de nombres distribus    */   
 /*                                      uniformment sur [0,1]    )   */ 
 /*                                                                    */ 
 /*                               */  
 /*                                                                    */ 
 /**********************************************************************/ 
   main()  
   {  
 
      FILE *fp1;
      double eps, stat[20], cte[20], var[20], *u, **MM, *NN, q1[6], *cvm2, *cvm3, *cvm4, *cvm5, *cvm6, q2[6]; 
      long int it, i, j, k, rang, taille[20]; 
      int n, p, lag, *rangs;
      long int *ii;   
      unsigned long int i0, j00, k0;   
      time_t *tloc;   
   
      
   
      /****  Fixation du seed  ****/ 
      ii = (long int *)malloc(sizeof(long int));   
      tloc=(time_t*)malloc(sizeof(time_t));   
      *ii=time(tloc);   
      j00=*ii*rand()*123;   
      k0=*ii*rand()*756;   
      i0=*ii*rand()*6675;   
      kisset(i0,j00,k0);     
   
      fp1 = fopen("q_bds_classic.txt","a");  /** fichiers  **/ 
   
      p =6;
   
   
   
      /***Tailles n de sries  considrer ***/    
   
      taille[0]  = 20; 
      taille[1]  = 50;  
      taille[2]  = 100; 
      taille[3]  = 200; 
      taille[4]  = 500;
      taille[5]  = 1000;
      taille[6]  = 2500;
      taille[7]  = 5000; 
   	  taille[8]  =10000;   
   
      it = 10000;   /** Nombre d'iterations **/ 
   
      rang  = (int)(.95*it);
   
   
   
      cvm2 = calloc((it+1), sizeof(double));
      cvm3 = calloc((it+1), sizeof(double));
      cvm4 = calloc((it+1), sizeof(double));
      cvm5 = calloc((it+1), sizeof(double));
      cvm6 = calloc((it+1), sizeof(double));
   
      fprintf(fp1, "\\begin{center}\n{\\sc Tableau }: Quantiles for Classical BDS Stat \\\\"); 
   
      fprintf(fp1, "\\begin{tabular}{llllll} \n\\hline \n"); 
      fprintf(fp1," $n$  & $p=2$ &  $p=3$ &  $p=4$ & $p=5$ & $p=6$ \\\\\\hline \n\n");  
   
   	/******* Dbut de la simulation *******/ 
	  u = (double *)calloc(500,sizeof(double)); 
	  eps=1.0;
      for(i=2;i<3;i++)
      { 
         n = 250;
      
         
         
      
         for(k=0;k<it;k++)
         {
            for(j=0;j<n;j++)  /* echantillon de taille n */ 
            {  
               u[j] = rnorm();  
            }
         
            bdsstat(u,  n, p,  eps, stat);
         
         
            cvm2[k] = fabs(stat[2]); 
            cvm3[k] = fabs(stat[3]); 
            cvm4[k] = fabs(stat[4]);  
            cvm5[k] = fabs(stat[5]); 
            cvm6[k] = fabs(stat[6]);
         
         
         
         
         
            if( (k % 100) == 0) printf("%d ", 1+ k/100); 
         } 
      
         quick_sort(cvm2,0,it); 
         quick_sort(cvm3,0,it); 
         quick_sort(cvm4,0,it); 
         quick_sort(cvm5,0,it); 
         quick_sort(cvm6,0,it); 
      
      
      
      
         q1[0] = cvm2[rang]; q1[1] = cvm3[rang]; q1[2] = cvm4[rang];  q1[3] = cvm5[rang]; q1[4] = cvm6[rang];
      
      
      
      
      
      
      
         printf("\n %d  & %.6f &  %.6f &  %.6f & %.6f & %.6f  \\\\ \n",n, q1[0], q1[1], q1[2], q1[3], q1[4]); 
         fprintf(fp1," %d  & %.6f &  %.6f &  %.6f & %.6f & %.6f  \\\\ \n",n, q1[0], q1[1], q1[2], q1[3], q1[4]); 
      
      
      
         printf("\n n= %d done\n\n",n);  
      
      
      
         //free(u) ; free(rangs); //free(MM);
      
      
      } 
      fprintf(fp1, "\n\\end{tabular}"); 
   
   
      fprintf(fp1, "\n\\end{center}\n\n"); 
      fclose(fp1); 
   
      printf("done...\n"); 
   
      free(cvm2); free(cvm3); free(cvm4); free(cvm5); free(cvm6);
   } 
