#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <malloc.h>
#include <sys/types.h>
#include <time.h>

int Bias_Correction;



#ifndef max
#define max(a,b)    (((a) > (b)) ? (a) : (b))
#endif
#ifndef min
#define min(a,b)    (((a) < (b)) ? (a) : (b))
#endif

/****************************************************************************
 **                                                                        **
 **     Fonction:  kiss.c                                                  **
 **     (Construit par Alexandre M. Berred, tire de ....                   **
 **                                                                        **
 **     Cette fonction retourne un nombre situe dans  l'intervalle [0,1].  **
 **                                                                        **
 ****************************************************************************/

struct seed_type { unsigned long int i;
                   unsigned long int j;
                   unsigned long int k;
                  }

/* seed = {314159265L, 362436069L, 521288629L}; */
 seed = {274159265L, 392436169L, 721287629L};
/* seed = {453219181L, 545870217L, 165890643L}; */
/* seed = {314159265L, 362436069L, 521288629L}; */
/* seed = {314159265L, 362436069L, 521288629L}; */
/* seed = {314159265L, 362436069L, 521288629L}; */
/* seed = {314159265L, 362436069L, 521288629L}; */
/*seed = {314159265L, 362436069L, 521288629L};  */

void kisset(unsigned long int ii,unsigned long int jj,unsigned long int kk)
{
	seed.i=ii; seed.j=jj; seed.k=kk;
}

double kiss()
{
   /* debut */

   seed.j = seed.j ^ (seed.j<<17);
   seed.k = (seed.k ^ (seed.k<<18)) &  0x7FFFFFFFL;
   return (1+ (seed.i = 69069L*seed.i + 23606797L) +
         (seed.j ^= (seed.j>>15)) + (seed.k ^= (seed.k>>13))) /
         4294967296.;

   /* fin */

}



/****************************************************************************
*
*  Nom: quick_sort
*  But: Effectue un tri de Hoare du tableau t entre les elements situes
*       entre lo et hi.
*  Parametres:  *t: C'est un pointeur sur la premiere case du tableau.
*               lo: Valeur d'index minimale du tableau.
*               hi: Valeur d'index maximale du tableau.
*
*  Auteur: Christian Beaudoin
*  Date: Lundi 27 janvier 1997
*
****************************************************************************/

void quick_sort(double *t, int lo, int hi)
{
    int i,j;
    double mid;
    double tmp;


    i=lo; j=hi;
    mid = t[  (lo + hi) >> 1 ]; /* On choisit le pivot. */

    /* On met les elements inferieurs au pivot a gauche
       et les elements superieurs au pivot a droite. */
    do
    {
        while (t[i] < mid) i++;
        while (mid < t[j]) j--;

        if (i <= j)
        {
            /* On echange deux elements. */
            tmp = t[i];
            t[i++] = t[j];
            t[j--] = tmp;
        }
    } while (i <=j);

    if (lo < j) quick_sort(t, lo, j);   /* On trie la partie gauche. */
    if (i < hi) quick_sort(t, i, hi);   /* On trie la partie droite. */
}


double bds_prod_integral_comp(double *xx, int p)
{
	short i, j,ca,ixa;
	short l,p2;
	double *x,Var1,Var2,Var3,Var4,*a,*b;
	x=(double *) calloc(p,sizeof(double));
	a=(double *) calloc(p+2,sizeof(double));
	b=(double *) calloc(p+2,sizeof(double));

	for(j=0;j<p;j++) x[j]=min(xx[j],1.0-xx[j]);
	quick_sort(x,0,p-1);
	for(j=0;j<p;j++){a[j+1]=x[j]; }
	a[0]=0.0; a[p+1]=0.5;

	Var1=0.0;
	Var2=0.0;

	for(j=0;j<=p;j++)
	{

		for(l=0;l<pow(2,j);l++)
		{
			Var3=pow(2.0,p-j);
			Var4=1.0;
			ca=0;
			for(i=0;i<j;i++)
			{
				ixa=0;
				p2=(short)pow(2,i);
				p2=l&p2;
				if(p2 !=0) ixa=1; // is x_i in A (A is represented by l//
				//printf("\n ixa= %d",ixa);
				ca+=ixa;
				if(ixa==1) {Var4=Var4*x[i];}
			}
			//printf("\n %d %d %d",j, l, ca);

			Var1=Var1+Var3*Var4*((pow(a[j+1],p-ca+1)-pow(a[j],p-ca+1))/(p-ca+1)-
				(pow(a[j+1],p-ca+2)-pow(a[j],p-ca+2))/(p-ca+2));
			Var2=Var2+Var4*((pow(1-a[j],j-ca+1)-pow(1-a[j+1],j-ca+1))/(j-ca+1)-
				(pow(1-a[j],j-ca+2)-pow(1-a[j+1],j-ca+2))/(j-ca+2));
		}

	}
	Var1=2*(Var1+Var2);
	//printf("\n Var1= %f \n",Var1);
	return Var1;
}



//================================



   void rank(double *x, int n, int *y)

   {
      int i, j;
      int  rr;




      for(i=0;i<n;i++)
      {
         rr = 1;
         for(j=0;j<n;j++)
         {
            if(x[j] < x[i])
               rr += 1;
         }
         y[i] = rr;
      }
   }


   void rang(double *x, int n, double *y)
   {
      int i, j;
      double  rr;




      for(i=0;i<n;i++)
      {
         rr = 1.0;
         for(j=0;j<n;j++)
         {
            if(x[j] < x[i])
               rr += 1.0;
         }
         y[i] = rr/((double) n);
      }
   }
/************************************************************************/
/****  Date: April 29, 2003,    Bruno Rmillard                       ***/
/****  Email:  bruno.remillard@hec.ca                                 ***/
/****  Calculate the Cramer-von Mises statistics of                   ***/
/****  the BDS                                                        ***/
/****  Commentd added Sep 16, 2006                                    ***/
/************************************************************************/



/* #include "../../LibC/rang.c" */

double mini( double u, double v)
{
    if(u < v)
        return u;
    else
        return v;
}

double maxi( double u, double v)
{
    if(u < v)
        return v;
    else
        return u;
}

double Gtilde_n(int m, int n,int correct)
{
	double t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12,t13,t14,t15,t16,t17,t18,t19,t20,t22,t23,t27,t28,t29,
	tt1,tt2,tt3,tt6,tt7,tt8,tt9;
	if (correct==0)
	{
		t0=1.0/(m+1.0);
	}
	else
	{
		switch(m)
		{
		case 2:
			t1 = n*n;
			t0 = (5.0*t1*n+t1-4.0)/n/(t1-1.0)/15.0;
			break;
		case 3:
			t1 = n*n;
			t2 = t1*t1;
			t16 = pow(n-1.0,2.0);
			t0 = (105.0*t2*n-36.0*t2-49.0*t1*n-120.0*t1+196.0*n-64.0)/t1/(n+1.0)/t16
				/420.0;
			break;
		case 4:
			t1 = n*n;
			t2 = t1*n;
			t3 = t1*t1;
			t19 = n-1.0;
			t20 = t19*t19;
			t0 = (63.0*t3*t2-59.0*t3*t1-39.0*t3*n-65.0*t3+192.0*t2-44.0*t1+24.0*n
				-48.0)/t2/(n+1.0)/t20/t19/315.0;
			break;
		case 5:
			t1 = n*n;
			t2 = t1*t1;
			t3 = t2*t2;
			t7 = t1*n;
			t22 = pow(n-1.0,2.0);
			t23 = t22*t22;
			t0 = (231.0*t3*n-362.0*t3-88.0*t2*t7-142.0*t2*t1+1199.0*t2*n-736.0*t2
				-1342.0*t7+2608.0*t1-792.0*n-384.0)/t2/t23/(n+1.0)/1386.0;

			break;
		case 6:
			t1 = n*n;
			t2 = t1*n;
			t3 = t1*t1;
			t4 = t3*t3;
			t16 = t3*n;
			t22 = 2145.0*t4*t2-4775.0*t4*t1+650.0*t4*n-290.0*t4+15951.0*t3*t2-18165.0
				*t3*t1-14794.0*t16+51190.0*t3-94016.0*t2+128696.0*t1-48256.0*n-12224.0;
			t27 = n-1.0;
			t28 = t27*t27;
			t29 = t28*t28;
			t0 = t22/t16/(n+1.0)/t29/t27/15015.0;
			break;
		 case 7:
		 t2 = n*n;
		 t3 = n*t1;
		 t4 = t2*t2;
		 t5 = n*t4;
		 t6 = t3*t3;
		 t7 = n*t6;
		 t8 = t4*t4;
		 t9 = n*t8;
		 t10 = t5*t5;
		 t11 = n*t10;
		 t12 = t6*t6;
		 t13 = n*t12;

		 tt1 = n-1.0;
		 tt2 = tt1*tt1;
		 tt3 = tt1*tt2;
		 tt6 = tt3*tt3;

		 t22=6435.0*t13-18712.0*t12+9495.0*t11+608.0*t10+61729.0*t9-110776.0*t8-
		 42947.0*t7+341104.0*t6-479240.0*t5+375424.0*t4-1063824.0*t3+2157568.0*t2
		 -969600.0*n-178176.0;
		 t0=t22/t6/tt6/(n+1.0)/51480.0;
		 break;
		 case 8:
         t2 = n*n;
		 t3 = n*t1;
		 t4 = t2*t2;
		 t5 = n*t4;
		 t6 = t3*t3;
		 t7 = n*t6;
		 t8 = t4*t4;
		 t9  = n*t8;
		 t10 = t5*t5;
		 t11 = n*t10;
		 t12 = t6*t6;
		 t13 = n*t12;
		 t14 = t7*t7;
		 t15 = n*t14;

		 tt1 = n-1.0;
		 tt2 = tt1*tt1;
		 tt3 = tt1*tt2;
		 tt6 = tt3*tt3;
		 tt7 = tt1*tt6;

		 t22 = -12155.0*t15+43859.0*t14-38539.0*t13+3535.0*t12-141933.0*t11+
		 363153.0*t10-3145.0*t9-1195339.0*t8+2435148.0*t7-2875160.0*t6
		 +325040.0*t5+5209904.0*t4+6000320.0*t3-28085888.0*t2+14707584.0*n+2175744.0;
		 t0=-t22/tt7/t7/(n+1.0)/109395.0;
		 break;
		 case 9:

         t2 = n*n;
		 t3 = n*t1;
		 t4 = t2*t2;
		 t5 = n*t4;
		 t6 = t3*t3;
		 t7 = n*t6;
		 t8 = t4*t4;
		 t9 = n*t8;
		 t10 = t5*t5;
		 t11 = n*t10;
		 t12 = t6*t6;
		 t13 = n*t12;
		 t14 = t7*t7;
		 t15 = n*t14;
		 t16 = t8*t8;
		 t17 = n*t16;

		 tt1 = n-1.0;
		 tt2 = tt1*tt1;
		 tt3 = tt1*tt2;
		 tt6 = tt3*tt3;
		 tt7 = tt1*tt6;
		 tt8 = tt2*tt6;


		 t22 = 969969.0*t17-4194666.0*t16+5253766.0*t15-1647450.0*t14+
		 13556158.0*t13-45411366.0*t12+18232552.0*t11+154442946.0*t10-409700135.0*t9
		 +575056776.0*t8-620830054.0*t7+647245984.0*t6+2218609328.0*t5-
		 9033482624.0*t4+876226496.0*t3+19210712320.0*t2-11453856640.0*n-1434122240.0;

		 t0 = t22/t8/tt8/(n+1.0)/9699690.0;
		 break;
		 case 10:

         t2 = n*n;
		 t3 = n*t1;
		 t4 = t2*t2;
		 t5 = n*t4;
		 t6 = t3*t3;
		 t7 = n*t6;
		 t8 = t4*t4;
		 t9 = n*t8;
		 t10 = t5*t5;
		 t11 = n*t10;
		 t12 = t6*t6;
		 t13 = n*t12;
		 t14 = t7*t7;
		 t15 = n*t14;
		 t16 = t8*t8;
		 t17 = n*t16;
		 t18 = n*t17;
		 t19 = n*t18;

		 tt1 = n-1.0;
		 tt2 = tt1*tt1;
		 tt3 = tt1*tt2;
		 tt6 = tt3*tt3;
		 tt7 = tt1*tt6;
		 tt8 = tt2*tt6;
		 tt9 = tt3*tt6;

		 t22 = 1322685.0*t19-6685215.0*t18+10894380.0*t17-6045240.0*t16+22609020.0*t15
		 -90601320.0*t14+72405930.0*t13+304430910.0*t12-1058722305.0*t11
		 +1768846695.0*t10-1924199190.0*t9+1330156170.0*t8-3794929272.0*t7
		 +1382941960.0*t6+37670635008.0*t5-187362655040.0*t4+77731358592.0*t3
		 +275172164224.0*t2-183600380928.0*n-20046683136.0;

		 t0 = t22/t9/tt9/(n+1.0)/14549535.0;
		}
	}
	return t0;
}

double M(double u, double v)   /*** M(u,v) with dG ***/

{
    double u1,v1,s,t, s3, t3;
    u1 = mini(u,1.0-u);
    v1 = mini(v,1.0-v);
    s = mini(u1,v1);
    t = maxi(u1,v1);
    t3 = t*t*t;
    s3 = s*s*s;


    return  1.0/6.0 - s3 -2.0*t3/3.0 + s*(1.0+s3)/3.0    +t*(1.0+t3)/3.0    +s*t*(1.0-t);
}


double N(double u)   /*** N(u) with dG ***/

{
    double v;

    v  = (u-0.5)*(u-0.5);

    return 187.0/480.0 -0.75*v + 0.5*v*v;
}



void matM(int n, double *NN, double **MM)
{
    int i,j,k;
    double t,t0,v;
    NN[0] = 1.0;
    MM[0][0] = 1.0;
    for(i=1;i<=n;i++)
    {
        MM[i][0] = 1.0;
        MM[0][i] = 1.0;
        t =  1.0*i/((double) n+1);
		v=(t-0.5)*(t-0.5);
		if(Bias_Correction==0) t0=187.0/480.0 -0.75*v + 0.5*v*v;
		k=min(i,n+1-i);
		if(Bias_Correction==1)
		{
			t0 = (-60.0*k*n+30.0*k*k*k-15.0*k*k-15.0*k*k*k*k+45.0*k*k*k*k*n-60.0*k*k*k*n+75.0*n*k*k-90.0*k*k*k*n*n+45.0*k*n*n*n*n+90.0*n*n*k*k+30.0*k*n*n*n-75.0*k*n
				*n-26.0*n+21.0*n*n*n*n*n-45.0*n*n+45.0*n*n*n*n+5.0*n*n*n)/n/pow(n+1.0,3.0)/(n
				-1.0)/90.0;

		}

        NN[i] = t0;
        MM[i][i] = M(t,t);
        for(j=1;j<i;j++)
        {
            MM[i][j] = M(t, 1.0*j/((double) n+1));
            MM[j][i] = MM[i][j];
        }
    }
}



void newmatM(int n, double *NN, double **MM)

{
    int i,j,k;
    double t, t2;
    for(i=0;i<=n;i++)
    {
        t = 1.0-  1.0*i/((double) n+1);
        t2 = t*t;
		k=i;
        if(Bias_Correction==0) NN[i] = t2-0.5*t2*t2;
		if(Bias_Correction==1) NN[i]=(12.0*k*k*k*n-12.0*n*n*k*k+12.0*n*n*k+6.0*n*k-18.0*n*k*k-2.0*n-4.0*k-3.0*n*n+3.0*k*k+4.0*k*k*k-3.0*k*k*k*k+3.0*n*n*n*n+2.0*n*n*n)/n/(n-1.0)/pow(n+
			1.0,2.0)/6.0;

        MM[i][i] = t2;
        for(j=0;j<i;j++)
        {
            MM[i][j] = t2;
            MM[j][i] = MM[i][j];
        }
    }
}


void matM_BDS(int n, double **MM, double eps)/* Setting MM for tilde Sn */

{
    int i,j;
    double t;

    t =  eps*(n+1);
    for(i=1;i<=n;i++)
    {
        MM[i][i] = 1.0;
        for(j=1;j<i;j++)
        {
            MM[i][j] = (i-j <= t);
            MM[j][i] = MM[i][j];
        }
    }
}


double tilde_F(double u, double t)
{
    double s = u+t;
    double v = u-t;


    if(s< 1.0) {
        if( v>0.0)
            return s-v;
        else
            return s;}
    else {
        if( v>0.0)
            return 1.0-v;
        else
            return 1.0;}
}


void vec_BDS(int n, double *NN, double eps)

{
    int i;
    double t;


    for(i=1;i<=n;i++)
    {
        t =  1.0*i/((double) n+1);
        NN[i] = tilde_F(t,eps);
    }
}


void puiss(int p, int n, double *c)
{
    int k;
    double t;
    if(Bias_Correction==0) t = 1.0/3.0;
	if(Bias_Correction==1)
	{
		t=(5.0*n*n*n+n*n-4.0)/n/(n*n-1.0)/15.0;
	}
	c[0]=1.0;
    for(k=1;k<=p;k++){ c[k] = t*c[k-1]; }
}


void puiss_BDS(int p, int n, double *c, double eps)

{
    int k,m;
    double t;
    if(Bias_Correction==0) t = 2*eps-eps*eps;
	if(Bias_Correction==1)
	{
		m=floor((n+1)*eps);
		t=2*m/(n-1.0)-m*(m+1.0)/(n*(n-1.0));
	}

    c[0] = 1.0;

    for(k=1;k<=p;k++){ c[k] = t*c[k-1]; }
}
void puiss_BDS_star(int p, int n, double *c, double eps)

{
    int k;
    double t,t0;
    if(Bias_Correction==0) t0 = 2*eps-eps*eps;
	if(Bias_Correction==1)
	{
		t=eps;
		k=floor((n+1)*min(t,1-t));
		if(t<= 0.5) t0 = (-2.0*t*k*n+t+k*k-2.0*t*k+3.0*t*n+2.0*t*n*n)/(n+1.0)/n;
        if(t>0.5) t0 = (1.0+2.0*t*k*n+2.0*n-t-2.0*k+k*k-2.0*k*n+2.0*t*k-t*n+n*n)/(n+1.0)/n;
	}
    t=t0;
    c[0] = 1.0;

    for(k=1;k<=p;k++){ c[k] = t*c[k-1]; }
}

void bds_rank(int *rangs, int n, int p, double *stat, double **MM, double *NN, double *cte)  /*** TN_star  ***/
/*  =====  The statistics $\tilde T_n^\star$ in our JASA 2006 Paper  ====*/

/* Before calling this routine you need  to set MM, NN and cte
MM and  NN are set via the program matM
cte is set by the program puiss
*/
{

    int i,j,k;

    double m,a, b, c, *sum1, *sum2, *sum3;

    sum1 = (double *)calloc(p+1,sizeof(double));
    sum2 = (double *)calloc(p+1,sizeof(double));
    sum3 = (double *)calloc(p+1,sizeof(double));


    for(k=2;k<=p;k++)
    {
        sum1[k] = 0.0;
        sum2[k] = 0.0;
        sum3[k] = 0.0;
    }



    for(i=0; i<n ;i++)
    {
        b = NN[rangs[i]];
        c = MM[rangs[i]][rangs[i]];

        for(k=2;k<=p;k++)
        {
            b *= NN[rangs[i+k-1]];
            sum2[k] += b;
            c *= MM[rangs[i+k-1]][rangs[i+k-1]];
            sum3[k] += c;

        }
        for(j=0;j< i;j++)
        {
            a = MM[rangs[i]][rangs[j]];

            for(k=2;k<=p;k++)
            {
                a *= MM[rangs[i+k-1]][rangs[j+k-1]];
                sum1[k] += a;
            }
        }
    }


    for(k=2;k<=p;k++){
        m = (double) n;
        stat[k] =  m*cte[k] -2.0*sum2[k] + 2.0*sum1[k]/m +sum3[k]/m;
        stat[k]=4*stat[k]; /* to have the same definition as in the JASA Paper */
    }

    free(sum1); free(sum2); free(sum3);
}


void var_bds(double eps, int p, double *var)
{
    int k, j;
    double v, g, eps2,sigma;

    eps2 = eps*eps;
    v= 2*eps-eps2;

    if(eps < 0.5)
        g = 4.0*eps2-10.0*eps*eps2/3.0;
    else
        g = -1.0/3.0 +2.0*eps-2*eps*eps2/3.0;

    for(k=2;k<=p;k++)
    {
        sigma = 0.0;
        for(j=1;j<=k-1;j++) {
            sigma += 2.0*pow(g,k-j)*pow(v,2*j);
        }
        sigma += pow(g,k) + (k-1)*(k-1)*pow(v,2*k)
            -k*k*g*pow(v,2*k-2);
        sigma *= (double)4;
        var[k] = sigma;
    }

}


void bds_rank_lebaron(int *rangs, int n, int p, double *stat, double **MM, double *cte, double  *var)   /*** SN  ***/
/*  =====  The statistics $\tilde S_n$ in our JASA 2006 Paper  ====*/

/* Before calling you need to set MM,  cte and var.
MM is set by the routine matM_BDS
cte is set by the routine puiss_BDS
var is set by the routine var_BDS
*/

{

    int i,j,k;

    double m, a, *sum1;


    sum1 = (double *)calloc(p+1,sizeof(double));




    for(k=2;k<=p;k++)
    {
        sum1[k] = 0.0;
    }

    for(i=0; i<n ;i++)
    {
        for(j=0;j< i;j++)
        {
            a = MM[rangs[i]][rangs[j]];

            for(k=2;k<=p;k++)
            {
                a *= MM[rangs[i+k-1]][rangs[j+k-1]];
                sum1[k] += a;
            }
        }
    }

    m = (double) n;

    for(k=2;k<=p;k++){

        stat[k] =  sqrt(m)*(2.0*sum1[k]/((m-1)*m) -cte[k])/sqrt(var[k]);
    }
    free(sum1);
}



void bds_rank_lebaron_prod(int *rangs, int n, int p, double *stat, double *NN, double *cte, double  *var)  /*** SN_star  ***/
/*  =====  The statistics $\tilde S_n^\star$ in our JASA 2006 Paper  ====*/

/* Before calling you need to set NN,  cte and var.
NN is set by the routine vec_BDS
cte is set by the routine puiss_BDS
var is set by the routine var_BDS
*/

{

    int i,k;

    double m,a, *sum1;

    sum1 = (double *)calloc(p+1,sizeof(double));

    for(k=2;k<=p;k++)
    {
        sum1[k] = 0.0;
    }

    for(i=0; i<n ;i++)
    {
        a = NN[rangs[i]];
        for(k=2;k<=p;k++)
        {
            a *= NN[rangs[i+k-1]];
            sum1[k] += a;
        }
    }

    m = (double) n;
    for(k=2;k<=p;k++){

        stat[k] =  2.0*sqrt(m)*(sum1[k]/m -cte[k])/sqrt(var[k]);
    }
    free(sum1);
}



void bds_rank_2(int *rangs, int n, int p, double *stat, double **MM, double *NN, double *cte)   /*** TN  ***/
/*  =====  The statistics $\tilde T_n $ in our JASA 2006 Paper  ====*/

/* Before calling you need to set MM, NN and cte.
MM and NN are set by the routine newmatM
cte is set by the routine puiss
*/

{

    int k, i1, i2, j1, j2, t1, t2, t3;

    double m,a, b, *sum1, *sum2, *sum3;

    sum1 = (double *)calloc(p+1,sizeof(double));
    sum2 = (double *)calloc(p+1,sizeof(double));
	sum3 = (double *)calloc(p+1,sizeof(double));


    for(k=2;k<=p;k++)
    {
        sum1[k] = 0.0;
        sum2[k] = 0.0;
		sum3[k] = 0.0;
    }

    for(i1=1; i1<n ;i1++)
    {

        for(j1=0;j1< i1;j1++)
        {
            t1 = abs(rangs[i1]-rangs[j1]);



            for(i2=1; i2<i1 ;i2++)
            {
                for(j2=0;j2< i2;j2++)
                {
                    t2 = abs(rangs[i2]-rangs[j2]);
                    a = MM[t1][t2];

                    for(k=1;k<p;k++)
                    {
                        t3 = abs(rangs[i1+k]-rangs[j1+k]);
                        t2 = abs(rangs[i2+k]-rangs[j2+k]);
                        a *= MM[t3][t2];
                        sum1[k+1] += a;
                    }
                }
            }


        }
    }
	for(i1=1; i1<n ;i1++)
    {

        for(j1=0;j1< i1;j1++)
        {
            t1 = abs(rangs[i1]-rangs[j1]);



                for(j2=0;j2< i1;j2++)
                {
                    t2 = abs(rangs[i1]-rangs[j2]);
                    a = MM[t1][t2];

                    for(k=1;k<p;k++)
                    {
                        t3 = abs(rangs[i1+k]-rangs[j1+k]);
                        t2 = abs(rangs[i1+k]-rangs[j2+k]);
                        a *= MM[t3][t2];
                        sum3[k+1] += a;
                    }
                }



        }
    }

    for(i1=1; i1<n ;i1++)
    {

        for(j1=0;j1< i1;j1++)
        {
            t1 = abs(rangs[i1]-rangs[j1]);
            b  = NN[t1];
            for(k=1;k<p;k++)
            {
                t1 = abs(rangs[i1+k]-rangs[j1+k]);
                b *= NN[t1];
                sum2[k+1] += b;
            }

        }
    }


    m = (double) n;
    for(k=2;k<=p;k++){

        stat[k] = m*cte[k] -4.0*sum2[k]/(m-1.0) + 4.0*(2*sum1[k]+sum3[k])/(m*(m-1.0)*(m-1.0)) ;
    }

    free(sum1); free(sum2); free(sum3);
}


void bds_rank_int(int *rangs, int n, int p, double *stat)     /*** IN  ***/
/*  =====  The statistics $\tilde I_n in our JASA 2006 Paper  ====*/

{

    int i,j,k, a,b,c, *sum1;

    double m ;

    m = 1.0/((double ) n+1);

    sum1 = (int *)calloc(p+1,sizeof(int));

    for(k=2;k<=p;k++)
    {
        sum1[k] = 0;
    }

    for(i=1; i<n ;i++)
    {
        for(j = 0; j < i; j++)
        {
            a = n+1 - abs(rangs[i]-rangs[j]);
            b = a*a;

            /* printf("\n %d %d %d %d  %d", rangs[i], rangs[j], abs(rangs[i]- rangs[j]), b); */

            for(k=2;k<=p;k++)
            {
                a = n+1 - abs(rangs[i+k-1]-rangs[j+k-1]);
                c = a*a;
                if(c < b)
                    b = c;
                /* printf("\n %d %d  a = %d  b = %d c = %d" , rangs[i], rangs[j], a, b, c); */
                sum1[k] += b;
            }
        }
    }

    m = (double) n;

    for(k=2;k<=p;k++)
        stat[k] =  sqrt(m)*(  2.0*sum1[k]/((m*m-1.0)*m*(m+1.0))  -Gtilde_n(k,n,Bias_Correction)  );

    free(sum1);
}




void bds_rank_lebaron_sup(int *rangs, int n, int p, double *stat)   /*** MN  ***/
/*  =====  The statistics $\tilde M_n $ in our JASA 2006 Paper  ====*/
{

    double **MM, *var, eps, *cte, *ks;
    int iep,j,k;

    cte = (double *)calloc(p+1,sizeof(double));
    var = (double *)calloc(p+1,sizeof(double));
    ks  = (double *)calloc(p+1,sizeof(double));

    for(k=2;k<=p;k++)
    {
        var[k] = 1.0;
        stat[k] = 0.0;
    }


    MM = (double **)calloc(n+1,sizeof(double *));
    for(j=0; j<=n; j++)
        MM[j] = (double *)calloc(n+1,sizeof(double));

    for(iep=1;iep<=n;iep++)
    {
        eps = 1.0*iep/((double) n+1);
        puiss_BDS(p,n, cte, eps);
        matM_BDS(n, MM, eps);

        bds_rank_lebaron(rangs, n, p, ks, MM, cte, var);

        for(k=2;k<=p;k++)
        {
            if( fabs(ks[k])> stat[k])
                stat[k] = fabs(ks[k]);
        }


    } /*fin du sup */

    free(var); free(cte); free(ks);
    for(j=0; j<=n; j++)
        free(MM[j]);
    free(MM);


}




void bds_rank_lebaron_sup_prod(int *rangs, int n, int p, double *stat)  /*** MN_star  ***/
/*  =====  The statistics $\tilde M_n^\star$ in our JASA 2006 Paper  ====*/

{


    double *NN, *var, eps, *cte, *ks;
    int iep, k;

    cte = (double *)calloc(p+1,sizeof(double));
    var = (double *)calloc(p+1,sizeof(double));
    ks  = (double *)calloc(p+1,sizeof(double));

    for(k=2;k<=p;k++)
    {
        var[k] = 1.0;
        stat[k] = 0.0;
    }


    NN = (double *)calloc(n+1,sizeof(double));


    for(iep=1;iep<=n;iep++)
    {
        eps = 1.0*iep/((double) n+1);
        puiss_BDS_star(p, n,cte, eps);
        vec_BDS(n, NN, eps);

        bds_rank_lebaron_prod(rangs, n, p, ks, NN, cte, var);

        for(k=2;k<=p;k++)
        {
            if( fabs(ks[k])> stat[k])
                stat[k] = fabs(ks[k]);
        }


    } /*fin du sup */


    free(var); free(cte); free(ks);
    free(NN);
}

/********** In_star ********************/


void bds_rank_prod_int(int *rangs, int n, int p, double *stat)
/*  =====  The statistics $\tilde I_n^\star$ in our JASA 2006 Paper  ====*/

{

    int i,j,k;

    double m,a, *sum1,*xx;

    sum1 = (double *)calloc(p+1,sizeof(double));
    xx = (double *)calloc(p,sizeof(double));
    for(k=2;k<=p;k++)
    {
        sum1[k] = 0.0;
    }

    for(i=0; i<n ;i++)
    {
        for(j=0;j<p;j++){xx[j]=rangs[i+j]/(n+1.0); }
        for(k=2;k<=p;k++)
        {
            a  =  bds_prod_integral_comp(xx,k);
            /* printf("\n a= %f k=%d", a,k); */
            sum1[k] += a;
        }
    }


    for(k=2;k<=p;k++){
        m = (double) n;
        stat[k] =  2.0*sqrt(m)*(sum1[k]/m -Gtilde_n(k,n,Bias_Correction));
    }
    free(sum1); free(xx);
}






 /**********************************************************************/
 /* programme: quantiles.c                                             */
 /*                                                                    */
 /* utilit: Calcul des diffrents quantiles de la loi des statisti-   */
 /*          ques du tau de Kendall ainsi que de Kolmogorov-Smirnov    */
 /*          et de Cramr-von Mises, pour diffrentes longueurs de     */
 /*          sries n, pour le processus de Kendall sriel de dlai 1  */
 /*                                                                    */
 /* fonctions utilises :-bds.c ( Calcul de bds-cvm )                  */
 /*                      -qsort.c (trie un vecteur en ordre croissant) */
 /*                      -kiss.c ( gnration de nombres distribus    */
 /*                                      uniformment sur [0,1]    )   */
 /*                                                                    */
 /* par: Bruno Rmillard, le 6 mai 2003  modified   Sep 20, 2006       */
 /*                                                                    */
 /**********************************************************************/
   main()
   {

      FILE *fp1,*fp2;
      double eps, stat[20],  *u, q1[10], *cvm2, *cvm3, *cvm4, *cvm5, *cvm6, q2[6],
             *cvm7, *cvm8, *cvm9, *cvm10;


      long int it, i, j, k, rang, taille[20];
      int n, p, lag, *rangs;
      long int *ii;
      unsigned long int i0, j00, k0;
      time_t *tloc;



      /****  Fixation du seed  ****/
      ii = (long int *)malloc(sizeof(long int));
      tloc=(time_t*)malloc(sizeof(time_t));
      *ii=time(tloc);
      j00=*ii*rand()*123;
      k0=*ii*rand()*756;
      i0=*ii*rand()*6675;
      kisset(i0,j00,k0);

      fp1 = fopen("q_tilde_In_jan11n200b.txt","a");  /** fichiers  **/
//      fp2 = fopen("per-tilde-In-jan11.txt","a");  /** fichiers  **/


      p =10;



      /***Tailles n de sries  considrer ***/

      taille[0]  = 20;
      taille[1]  = 50;
      taille[2]  = 200;
      taille[3]  = 250;
      taille[4]  = 500;
      taille[5]  = 1000;
      taille[6]  = 2500;
      taille[7]  = 5000;
   	  taille[8]  =10000;

      it = 10000 ;   /** Nombre d'iterations **/

      rang  = (int)(.95*it);



      cvm2 = calloc((it+1), sizeof(double));
      cvm3 = calloc((it+1), sizeof(double));
      cvm4 = calloc((it+1), sizeof(double));
      cvm5 = calloc((it+1), sizeof(double));
      cvm6 = calloc((it+1), sizeof(double));
      cvm7 = calloc((it+1), sizeof(double));
      cvm8 = calloc((it+1), sizeof(double));
      cvm9 = calloc((it+1), sizeof(double));
      cvm10 = calloc((it+1), sizeof(double));

      fprintf(fp1, "\\begin{center}\n{\\sc Tableau }: Quantiles for new CVM statistic $Bds _prod_int$ \\\\");


      fprintf(fp1, "\\begin{tabular}{llllllllllllllllllllllllllll} \n\\hline \n");
//      fprintf(fp1," $n$  & $p=2$ &  $p=3$ &  $p=4$ & $p=5$ & $p=6$ &  $p=7$ &  $p=8$ & $p=9$ & $p=10$\\\\\\hline \n\n");


   	/******* Dbut de la simulation *******/
      for(i=2;i<3;i++)
      {
         n = taille[i];

         u = (double *)calloc(n,sizeof(double));
         rangs = (int *)calloc(n+p,sizeof(int));

       Bias_Correction=1;

           for(k=0;k<it;k++)
         {
            for(j=0;j<n;j++)  /* echantillon de taille n */
            {
               u[j] = kiss();
            }

            rank(u, n, rangs);
            for(j=n;j<n+p;j++)
               rangs[j] = rangs[j-n];

            bds_rank_int(rangs, n, p, stat);
			//printf("\n %f",stat[4]);

            cvm2[k] = fabs(stat[2]);
            cvm3[k] = fabs(stat[3]);
            cvm4[k] = fabs(stat[4]);
            cvm5[k] = fabs(stat[5]);
            cvm6[k] = fabs(stat[6]);
            cvm7[k] = fabs(stat[7]);
            cvm8[k] = fabs(stat[8]);
            cvm9[k] = fabs(stat[9]);
            cvm10[k] = fabs(stat[10]);

fprintf(fp2,"%d  %f   %f   %f  %f  %f  %f  %f  %f  %f  \n",k,cvm2[k],cvm3[k],cvm4[k],cvm5[k],cvm6[k],cvm7[k],cvm8[k],cvm9[k],cvm10[k]);


            if( (k % 100) == 0) printf("%d ", 1+ k/100);
         }

         quick_sort(cvm2,0,it);
         quick_sort(cvm3,0,it);
         quick_sort(cvm4,0,it);
         quick_sort(cvm5,0,it);
         quick_sort(cvm6,0,it);
         quick_sort(cvm8,0,it);
         quick_sort(cvm9,0,it);
         quick_sort(cvm10,0,it);




         q1[0] = cvm2[rang]; q1[1] = cvm3[rang]; q1[2] = cvm4[rang];  q1[3] = cvm5[rang]; q1[4] = cvm6[rang];
         q1[5] = cvm7[rang]; q1[6] = cvm8[rang]; q1[7] = cvm9[rang];  q1[8] = cvm10[rang];


         printf("\n %d  & %f &  %f &  %f & %f & %f &  %f &  %f & %f & %f \\\\ \n",n, q1[0], q1[1], q1[2], q1[3], q1[4],q1[5], q1[6], q1[7], q1[8]);
         fprintf(fp1," %d  & %.6f &  %.6f &  %.6f & %.6f & %.6f & %.6f &  %.6f &  %.6f & %.6f \\\\ \n",n, q1[0], q1[1], q1[2], q1[3], q1[4],q1[5], q1[6], q1[7], q1[8]);




         printf("\n n= %d done\n\n",n);



         free(u) ; free(rangs);

      }
      fprintf(fp1, "\n\\end{tabular}");


      fprintf(fp1, "\n\\end{center}\n\n");
      fclose(fp1);

      printf("done...\n");
      free(cvm2); free(cvm3); free(cvm4); free(cvm5); free(cvm6); free(cvm7); free(cvm8); free(cvm9); free(cvm10);

   }
